VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsSeparadorDeTextos"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3586C6610348"
Option Explicit

' Esta classe trabalha com textos, possibilitando separar as strings de uma lista
' com determinado separador, separar partes de um nome completo de arquivo
' Substituir um ou um conjunto de caracteres em determinado texo

Public Enum arqSeparaNome
    arqSomente_Nome = 1
    arqSomente_Extencao = 2
    arqSomente_Path = 3
    arqSomente_Drive = 4
    arqSomente_Nome_e_Extencao = 5
End Enum

Public Function SeparaNomeArq(nome As String, QualParte As arqSeparaNome, Optional QuantosNiveis As Integer = 0) As String
    Dim Retorno As String
    Dim Pos As Long
    Dim Cont As Integer
    Dim Tam As Integer
    Dim auxPos As Integer
    
    Select Case QualParte
        Case arqSomente_Nome
            Retorno = nome
            Pos = InStr(1, Retorno, "\")
            If Pos <> 0 Then
                While InStr(Pos + 1, Retorno, "\") <> 0
                    Pos = InStr(Pos + 1, Retorno, "\")
                Wend
                Retorno = Right$(Retorno, Len(Retorno) - Pos)
            End If
            Pos = InStr(1, Retorno, ".")
            auxPos = 0
            While Pos > 0
                auxPos = Pos
                Pos = InStr(Pos + 1, Retorno, ".")
            Wend
            If auxPos > 0 Then
                Retorno = Left$(Retorno, auxPos - 1)
            End If
            Pos = InStr(1, Retorno, ":")
            If Pos > 0 Then
                Retorno = Right$(Retorno, Len(Retorno) - Pos)
            End If
        Case arqSomente_Extencao
            Retorno = nome
            Pos = InStr(1, Retorno, ".")
            auxPos = 0
            While Pos > 0
                auxPos = Pos
                Pos = InStr(Pos + 1, Retorno, ".")
            Wend
            If auxPos > 0 Then
                Retorno = Right$(Retorno, Len(Retorno) - auxPos)
            Else
                Retorno = ""
            End If
        Case arqSomente_Path
            Retorno = nome
            Pos = InStr(1, Retorno, "\")
            If Pos = 0 Then
                SeparaNomeArq = ""
                Exit Function
            End If
            Tam = QuantosNiveis + 1
            
            For Cont = 1 To Tam
                While InStr(Pos + 1, Retorno, "\") <> 0
                    Pos = InStr(Pos + 1, Retorno, "\")
                Wend
                Retorno = Left$(Retorno, Pos - 1)
                Pos = 1
                If Len(Retorno) <= 2 Then Exit For
            Next
            
        Case arqSomente_Drive
            Retorno = nome
            Pos = InStr(1, Retorno, ":")
            If Pos > 0 Then
                If Len(Retorno) > 2 Then
                    Pos = InStr(1, Retorno, ":\")
                    If Pos = 0 Then
                        Retorno = ""
                    Else
                        Retorno = Left$(Retorno, Pos)
                    End If
                Else
                    Retorno = Left$(Retorno, Pos)
                End If
                If Len(Retorno) < 2 Then
                    Retorno = ""
                End If
            Else
                Retorno = ""
            End If
        Case arqSomente_Nome_e_Extencao
            Retorno = nome
            Pos = InStr(1, Retorno, "\")
            If Pos <> 0 Then
                While InStr(Pos + 1, Retorno, "\") <> 0
                    Pos = InStr(Pos + 1, Retorno, "\")
                Wend
                Retorno = Right$(Retorno, Len(Retorno) - Pos)
            End If
            Pos = InStr(1, Retorno, ":")
            If Pos > 0 Then
                Retorno = Right$(Retorno, Len(Retorno) - Pos)
            End If
        Case Else
            Retorno = ""
    End Select
    SeparaNomeArq = Retorno
    
End Function

Public Sub SeparaTexto(Texto As String, Separador As String, parCol As Collection, Optional IgnoraVaziu As Boolean = True)
    Dim Pos As Long
    Dim Quant As Long
    Dim TXT As String
    Dim Fim As Boolean
    Fim = False
    TXT = Texto
    Quant = 0
    While parCol.Count > 0
        parCol.Remove 1
    Wend
    If Len(Separador) = 0 Then
        parCol.Add TXT
        Exit Sub
    End If
    Pos = InStr(1, TXT, Separador)
    While Pos = 1
        TXT = Right$(TXT, Len(TXT) - 1)
        Pos = InStr(1, TXT, Separador)
    Wend
    If Pos = 0 Then
        parCol.Add TXT
        Exit Sub
    End If
    While Pos <> 0
        While Pos = 1
            TXT = Right$(TXT, Len(TXT) - 1)
            Pos = InStr(1, TXT, Separador)
            If Not IgnoraVaziu Then parCol.Add ""
        Wend
        If Pos = 0 Then
            If Len(TXT) = 0 Then Fim = True
            GoTo FimDoWhile
        End If
        parCol.Add Left$(TXT, Pos - 1)
        If Pos <> Len(TXT) Then
            TXT = Right$(TXT, Len(TXT) - Pos)
            Pos = InStr(1, TXT, Separador)
        Else
            Pos = 0
            Fim = True
        End If
    Wend
FimDoWhile:
    If Not Fim Then
        parCol.Add TXT
    End If
End Sub

Public Function SubstituiCaracteres(Texto As String, Este As String, Optional PorEste As String = "", Optional IgnorarMaiusMinus As Boolean = False) As String
    Dim Quant As Long
    Dim strVet As New Collection
    Dim Retorno As String
    Dim Cont1 As Integer
    Dim Cont2 As Integer
    Dim Tam As Integer
    Dim EsteVai As Boolean
    Dim TesteLogico As Boolean
    Retorno = ""
    If Este = "," Then
        strVet.Add ","
        Quant = strVet.Count
    Else
        Call SeparaTexto(Este, ",", strVet)
        Quant = strVet.Count
    End If
    Tam = Len(Texto)
    For Cont1 = 1 To Tam
        For Cont2 = 1 To Quant
            If IgnorarMaiusMinus Then
                TesteLogico = (UCase(Mid$(Texto, Cont1, Len(strVet(Cont2)))) = UCase(strVet(Cont2)))
            Else
                TesteLogico = (Mid$(Texto, Cont1, Len(strVet(Cont2))) = strVet(Cont2))
            End If
            If TesteLogico Then
                EsteVai = False
                Exit For
            Else
                EsteVai = True
            End If
        Next
        If EsteVai Then
            Retorno = Retorno & Mid$(Texto, Cont1, 1)
        Else
            Retorno = Retorno & PorEste
            Cont1 = Cont1 + (Len(strVet(Cont2))) - 1
        End If
    Next
    SubstituiCaracteres = Retorno
End Function

Public Function ContaCaracteres(Texto As String, QualCaractere As String) As Integer
    Dim Pos As Integer
    Dim Quant As Integer
    Pos = InStr(1, Texto, QualCaractere, vbTextCompare)
    While Pos <> 0
        Quant = Quant + 1
        Pos = InStr(Pos + Len(QualCaractere), Texto, QualCaractere, vbTextCompare)
    Wend
    ContaCaracteres = Quant
End Function


