Attribute VB_Name = "mdlGenius"
Option Explicit

Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

Public Declare Function SetWindowRgn Lib "user32" _
       (ByVal hwnd As Long, ByVal hRgn As Long, _
       ByVal bRedraw As Boolean) As Long
Public Declare Function DeleteObject Lib "gdi32" _
       (ByVal hObject As Long) As Long
Public Declare Function ReleaseCapture Lib _
       "user32" () As Long
Public Declare Function SendMessage Lib "user32" _
       Alias "SendMessageA" (ByVal hwnd As Long, _
       ByVal wMsg As Long, ByVal wParam As Long, _
       lParam As Any) As Long
Private Declare Function CreateCompatibleDC Lib _
       "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib _
       "gdi32" (ByVal hDC As Long, ByVal hObject _
       As Long) As Long
Private Declare Function GetObject Lib "gdi32" _
       Alias "GetObjectA" (ByVal hObject As _
       Long, ByVal nCount As Long, lpObject As _
       Any) As Long
Private Declare Function CreateRectRgn Lib _
       "gdi32" (ByVal X1 As Long, ByVal Y1 As _
       Long, ByVal X2 As Long, ByVal Y2 As Long) _
       As Long
Private Declare Function CombineRgn Lib "gdi32" _
       (ByVal hDestRgn As Long, ByVal hSrcRgn1 _
       As Long, ByVal hSrcRgn2 As Long, ByVal _
       nCombineMode As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" _
       (ByVal hDC As Long) As Long
Private Declare Function GetPixel Lib "gdi32" _
       (ByVal hDC As Long, ByVal X As Long, _
       ByVal Y As Long) As Long

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)


Public Const WM_NCLBUTTONDOWN As Long = &HA1
Public Const HTCAPTION As Long = 2

Private Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Integer
  bmBitsPixel As Integer
  bmBits As Long
End Type

Public TempoEspera As Integer
Public Demonstracao As Boolean
Public IncrementoSequencia As Integer

Public Sub PlayWav(parNomeArquivo As String)
    Call sndPlaySound(parNomeArquivo, 0)
End Sub

Public Function GetBitmapRegion(cPicture As _
       StdPicture, cTransparent As Long)
  Dim hRgn As Long, tRgn As Long
  Dim X As Integer, Y As Integer, X0 As Integer
  Dim hDC As Long, BM As BITMAP
  'Cria um novo DC, ento procuramos a imagem
  hDC = CreateCompatibleDC(0)
  If hDC Then
    'Coloca o novo DC na Imagem
    SelectObject hDC, cPicture
    'Pega as dimenses e cria uma nova regio
    'de retangulo
    GetObject cPicture, Len(BM), BM
    hRgn = CreateRectRgn(0, 0, BM.bmWidth, BM.bmHeight)
    'Inicia procurando a imagem de cima para
    'baixo
    For Y = 0 To BM.bmHeight
      For X = 0 To BM.bmWidth
        'Procura uma linha de pxeis no
        'transparentes
        While X <= BM.bmWidth And GetPixel(hDC, _
              X, Y) <> cTransparent
          X = X + 1
        Wend
        'Marca o Incio da linha de pxeis no
        'transparentes
        X0 = X
        'Procura uma linha com Pxeis
        'transparentes
        While X <= BM.bmWidth And GetPixel(hDC, _
              X, Y) = cTransparent
          X = X + 1
        Wend
        'Cria uma nova regio que corresponda 
        'linha dos pxeis transparentes e ento
        'remove ele da regio principal
        If X0 < X Then
          tRgn = CreateRectRgn(X0, Y, X, Y + 1)
          CombineRgn hRgn, hRgn, tRgn, 4
          'Libera a memria usada para a nova
          'regio temporria
          DeleteObject tRgn
        End If
      Next X
    Next Y
    'Volta ao endereo de memria da imagem pronta
    GetBitmapRegion = hRgn
    'Libera memria apagando a imagem
    DeleteObject SelectObject(hDC, cPicture)
  End If
  'Libera memria apagando o DC criado
  DeleteDC hDC
End Function

'A funo GetBitmapRegion pede dois parmetros: a figura e uma cor a ser apagada. Se o fundo da sua figura for preto, voc pode usar a constante vbBlack e
'apagar toda a cor preta da figura. Lembrando que se a cor estiver dentro da figura, ela ser apagada tambm, deixando o form transparente naquele lugar.

Public Sub Esperar(pMilisegundos As Long)
    Call Sleep(pMilisegundos)
End Sub
Public Function GeraSequencia(Min As Variant, Max As Variant, Quantidade As Long, Optional Inteiros As Boolean = False) As Collection
    Dim locCol As New Collection
    Dim Num As Variant
    Do
        Randomize
        Num = Rnd * (Max + 1)
        If Inteiros Then
            Num = Int(Num)
        End If
        If Num >= Min Then
            If locCol.Count > 1 Then
                If (locCol(locCol.Count) = Num) And (locCol(locCol.Count - 1) = Num) Then
                    
                Else
                    locCol.Add Num
                End If
            Else
                locCol.Add Num
            End If
        End If
    Loop Until locCol.Count = Quantidade
    Set GeraSequencia = locCol
End Function

Public Function GiraCaracter(ByVal Origem As String, ByVal Chave As Integer, Optional Codificando As Boolean = True) As String
    Dim PosFim As Long
    Dim Pos As Long
    Dim Resposta As String
    Dim NovoNumero As Integer
    Dim locChave As Integer
    Resposta = ""
    PosFim = Len(Origem)
    locChave = Chave
    If PosFim = 0 Then Exit Function
    For Pos = 1 To PosFim
        NovoNumero = Asc(Mid$(Origem, Pos, 1))
        If Codificando Then
            NovoNumero = NovoNumero + locChave
            If NovoNumero > 255 Then
                NovoNumero = NovoNumero - 255
            End If
        Else
            NovoNumero = NovoNumero - locChave
            If NovoNumero < 0 Then
                NovoNumero = 255 + NovoNumero
            End If
        End If
        Resposta = Resposta & Chr(NovoNumero)
    Next
    GiraCaracter = Resposta
End Function

Public Function GiraCaracterAmarrado(ByVal Origem As String, ByVal Chave As Integer, Optional Codificando As Boolean = True) As String
    Dim PosFim As Long
    Dim Pos As Long
    Dim Resposta As String
    Dim NovoNumero As Integer
    Dim auxChave As Integer
    Dim locChave As Integer
    Resposta = ""
    PosFim = Len(Origem)
    locChave = Chave
    If PosFim = 0 Then Exit Function
    If Codificando Then
        For Pos = 1 To PosFim
            NovoNumero = Asc(Mid$(Origem, Pos, 1))
            NovoNumero = NovoNumero + locChave
            If NovoNumero > 255 Then
                NovoNumero = NovoNumero - 255
            End If
            Resposta = Resposta & Chr(NovoNumero)
            locChave = NovoNumero
        Next
    Else
        auxChave = locChave
        For Pos = PosFim To 1 Step -1
            NovoNumero = Asc(Mid$(Origem, Pos, 1))
            If Pos = 1 Then
                locChave = auxChave
            Else
                locChave = Asc(Mid$(Origem, Pos - 1, 1))
            End If
            NovoNumero = NovoNumero - locChave
            If NovoNumero < 0 Then
                NovoNumero = 255 + NovoNumero
            End If
            Resposta = Chr(NovoNumero) & Resposta
        Next
    End If
    
    GiraCaracterAmarrado = Resposta
End Function

'Public Function CarregaHallDaFama() As Variant
'    Dim ArqLivre As Integer
'    Dim locBuffer As String
'    Dim JaExiste As Boolean
'    Dim Pos As Long
'    Dim PosAnterior As Long
'    Dim auxIndice As Integer
'    Dim Cont As Integer
'
'    On Error GoTo TrataErro
'
'    JaExiste = (Dir(App.Path & "\Hall_Da_Fama.dat", vbArchive) <> "")
'
'    If JaExiste Then
'        ArqLivre = FreeFile
'        Open App.Path & "\Hall_Da_Fama.dat" For Binary As #ArqLivre
'        locBuffer = String(LOF(ArqLivre), " ")
'        Get #1, , locBuffer
'        Close ArqLivre
'        For Cont = 100 To 1 Step -1
'            locBuffer = GiraCaracterAmarrado(locBuffer, Cont, False)
'        Next
'        ReDim vetHallDaFama(1 To 1)
'        auxIndice = 1
'        PosAnterior = 1
'        Pos = 1
'        While (Pos <> 0) And (Pos < Len(locBuffer))
'            Pos = InStr(PosAnterior, locBuffer, Chr(4), vbTextCompare)
'            vetHallDaFama(auxIndice).NomePessoa = Mid$(locBuffer, PosAnterior, Pos - PosAnterior)
'            PosAnterior = Pos + 1
'
'            Pos = InStr(PosAnterior, locBuffer, Chr(4), vbTextCompare)
'            vetHallDaFama(auxIndice).Pontuacao = Mid$(locBuffer, PosAnterior, Pos - PosAnterior)
'            PosAnterior = Pos + 1
'        Wend
'    Else
'NAO_EXISTE:
'        ReDim vetHallDaFama(0 To 0)
'    End If
'
'    Exit Function
'TrataErro:
'    MsgBox "ERRO: " & Err.Number & vbCrLf & Err.Description & vbCrLf & _
'                    "O arquivo " & App.Path & "\Hall_Da_Fama.dat deve estar corrompido...", vbCritical, "Genius"
'    Err.Clear
'    GoTo NAO_EXISTE
'End Function

Public Sub CriarHallDaFama()
    Dim auxTexto As String
    Dim Cont As Integer
    Dim ArqLivre As Long
    
    For Cont = 1 To 10
        auxTexto = auxTexto & "0" & Chr(4) & "?" & Chr(4)
    Next
    
    For Cont = 0 To 33 Step 3
        auxTexto = GiraCaracterAmarrado(auxTexto, Cont)
    Next
    
    ArqLivre = FreeFile
    
    Open App.Path & "\Hall_Da_Fama.dat" For Binary As #ArqLivre
    Put #ArqLivre, , auxTexto
    Close ArqLivre
    
    
'    Get #1, , locBuffer
'    Close ArqLivre
'    For Cont = 33 To 1 Step -3
'        locBuffer = GiraCaracterAmarrado(locBuffer, Cont, False)
'    Next
    
End Sub

Public Function CarregaHallDaFama() As String
    Dim auxTexto As String
    Dim Cont As Integer
    Dim ArqLivre As Long
    
    If Dir(App.Path & "\Hall_Da_Fama.dat", vbArchive) = "" Then
        MsgBox "No encontrei o Hall da Fama." & vbCrLf & "Vou criar um novo...", vbInformation, "Hall da Fama"
        Call CriarHallDaFama
    End If
    
    ArqLivre = FreeFile
        
    Open App.Path & "\Hall_Da_Fama.dat" For Binary As #ArqLivre
    auxTexto = String(LOF(ArqLivre), " ")
    Get #ArqLivre, , auxTexto
    Close ArqLivre
    
    For Cont = 33 To 0 Step -3
        auxTexto = GiraCaracterAmarrado(auxTexto, Cont, False)
    Next
    
    CarregaHallDaFama = auxTexto
    
End Function

Public Sub SalvaHallDaFama(parTexto As String)
    Dim Cont As Integer
    Dim ArqLivre As Long
        
    For Cont = 0 To 33 Step 3
        parTexto = GiraCaracterAmarrado(parTexto, Cont)
    Next
    
    ArqLivre = FreeFile
    
    Open App.Path & "\Hall_Da_Fama.dat" For Binary As #ArqLivre
    Put #ArqLivre, , parTexto
    Close ArqLivre
    
End Sub

Public Sub CarregaConfiguracoes()
    Dim auxTexto As String
    Dim ArqLivre As Long
    Dim SepTxt As clsSeparadorDeTextos
    Dim auxCol As Collection
    Dim Cont As Integer
    
    If Dir(App.Path & "\Configuracoes.dat", vbArchive) = "" Then
        TempoEspera = 220
        Demonstracao = False
        IncrementoSequencia = 1
    Else
        ArqLivre = FreeFile
        Open App.Path & "\Configuracoes.dat" For Binary As #ArqLivre
        auxTexto = String(LOF(ArqLivre), " ")
        Get #ArqLivre, , auxTexto
        Close ArqLivre
        
'        For Cont = 33 To 0 Step -3
'            auxTexto = GiraCaracterAmarrado(auxTexto, Cont, False)
'        Next
        
        Set SepTxt = New clsSeparadorDeTextos
        Set auxCol = New Collection
        
        SepTxt.SeparaTexto auxTexto, Chr(4), auxCol
        
        TempoEspera = CInt(auxCol(1))
        If TempoEspera <= 0 Then TempoEspera = 120
        If TempoEspera > 60000 Then TempoEspera = 60000
        
        Demonstracao = CBool(auxCol(2))
        
        IncrementoSequencia = CInt(auxCol(3))
        If IncrementoSequencia <= 0 Then IncrementoSequencia = 1
        If IncrementoSequencia > 10 Then IncrementoSequencia = 10
        
    End If
    
    
    
End Sub

Public Sub SalvaConfiguracoes(parTempoEspera As Integer, parDemonstracao As Boolean, parIncrementoSequencia As Integer)
    Dim ArqLivre As Integer
    Dim auxTexto As String
    Dim Cont As Integer
        
    auxTexto = parTempoEspera & Chr(4) & parDemonstracao & Chr(4) & parIncrementoSequencia
    
'    For Cont = 0 To 33 Step 3
'        auxTexto = GiraCaracterAmarrado(auxTexto, Cont)
'    Next
    
    On Error Resume Next
    Kill App.Path & "\Configuracoes.dat"
    On Error GoTo 0
    
    ArqLivre = FreeFile
    Open App.Path & "\Configuracoes.dat" For Binary As #ArqLivre
    Put #ArqLivre, , auxTexto
    Close ArqLivre
    
End Sub

